/*
 *  어플명 : cqIME
 *  버  전 : 0.60.0
 *  작성자 : cq (undercover.cq@gmail.com)
 *  작성일 : 2010.03.26
 *  
 *  수정/배포 시 노키아까페 출처를 명시해 주세요. ^^
 *  감사합니다. 
 */
 
package net.cq.koreanIME;

import java.io.*;

import javax.microedition.io.Connector;
import javax.microedition.io.file.FileConnection;
import javax.microedition.midlet.*;

import org.eclipse.ercp.swt.mobile.MobileDevice;
import org.eclipse.ercp.swt.mobile.MobileShell;
import org.eclipse.ercp.swt.mobile.Screen;
import org.eclipse.swt.SWT;
import org.eclipse.swt.dnd.Clipboard;
import org.eclipse.swt.dnd.TextTransfer;
import org.eclipse.swt.dnd.Transfer;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseListener;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.FontData;
import org.eclipse.swt.widgets.*;

public class CQIME extends MIDlet implements Runnable, MouseListener /*SelectionListener*/ {
	
	private AutomataKR amKR;
		
	private boolean exiting = false;
	
	// 키보드 변경 관련 플래그
	private boolean isKorean = true;
    private boolean isSpecialKey01 = false;
    private boolean isSpecialKey02 = false;
    
    private boolean isQwerty = false;
    private boolean isQwertyHangul = false;
    private boolean isQwertyShift = false;
    private boolean isQwertyAlpha = false;
    private boolean isQwertyAlphaLower = false;
    private boolean isQwertySpkey = false;
    
    // 입력모드 변경
    private char inputMode = 'K';
    private char qtInputMode = 'K';
    
    private char btnStatus03;
	private char btnStatus06;
	private char lastInput;
	
	// 사용자 정의 특수문자
	private String[] spKeyTitle;
	private String[] spKeyString;
	
	private Thread UIThread;
    
	private Screen[] screens;
	private Display display;
	
    private MobileShell ezhShell;
    private MobileShell qwertyShell;
    
    private Clipboard cb;
    private TextTransfer textTransfer;
    
    private Font bigFont01;
    private Font bigFont02;
    private Font smallFont;
        
    // 이지한글
    private Text statusTextBox;
    private Text inputTextBox;
    
    private Button ezhButton01;
    private Button ezhButton02;
    private Button ezhButton03;
    private Button ezhButton04;
    private Button ezhButton05;
    private Button ezhButton06;
    private Button ezhButton07;
    private Button ezhButton08;
    private Button ezhButton09;
    private Button ezhButton10;
    private Button ezhButton11;
    private Button ezhButton12;
    
    private Button ezhETCButton01;
    private Button ezhETCButton02;
    private Button ezhETCButton03;
    private Button ezhETCButton04;
    private Button ezhETCButton05;
    private Button ezhETCButton06;
    private Button ezhETCButton07;
    private Button ezhETCButton08;
    private Button ezhETCButton09;
    
    private Button ezhSpecialButton01;
    private Button ezhSpecialButton02;
    private Button ezhSpecialButton03;
    private Button ezhSpecialButton04;
    private Button ezhSpecialButton05;
    private Button ezhSpecialButton06;
    private Button ezhSpecialButton07;
    private Button ezhSpecialButton08;
    private Button ezhSpecialButton09;
    private Button ezhSpecialButton10;
    private Button ezhSpecialButton11;
    private Button ezhSpecialButton12;
    private Button ezhSpecialButton13;
    private Button ezhSpecialButton14;
    private Button ezhSpecialButton15;
    private Button ezhSpecialButton16;
    private Button ezhSpecialButton17;
    private Button ezhSpecialButton18;
    private Button ezhSpecialButton19;
    private Button ezhSpecialButton20;
    private Button ezhSpecialButton21;
    private Button ezhSpecialButton22;
    private Button ezhSpecialButton23;
    private Button ezhSpecialButton24;
    

    // QWERTY 
    private Text qtStatusTextBox;
    private Text qtInputTextBox;
    
    private Button qwertyButton01;
    private Button qwertyButton02;
    private Button qwertyButton03;
    private Button qwertyButton04;
    private Button qwertyButton05;
    private Button qwertyButton06;
    private Button qwertyButton07;
    private Button qwertyButton08;
    private Button qwertyButton09;
    private Button qwertyButton10;
    private Button qwertyButton11;
    private Button qwertyButton12;
    private Button qwertyButton13;
    private Button qwertyButton14;
    private Button qwertyButton15;
    private Button qwertyButton16;
    private Button qwertyButton17;
    private Button qwertyButton18;
    private Button qwertyButton19;
    private Button qwertyButton20;
    private Button qwertyButton21;
    private Button qwertyButton22;
    private Button qwertyButton23;
    private Button qwertyButton24;
    private Button qwertyButton25;
    private Button qwertyButton26;
    private Button qwertyButton27;
    private Button qwertyButton28;
    private Button qwertyButton29;
    private Button qwertyButton30;
    private Button qwertyButton31;
    private Button qwertyButton32;
    private Button qwertyButton33;
    private Button qwertyButton34;
    private Button qwertyButton35;
    
    private Button qtETCButton01;
    private Button qtETCButton02;
    private Button qtETCButton03;
    private Button qtETCButton04;
    private Button qtETCButton05;
    private Button qtETCButton06;

    
    /**************************************************************************
     * MIDLET Start 
     *************************************************************************/
    
    public void startApp() {
        
    	// Create the eSWT UI thread. 
        if(UIThread == null) {
            UIThread = new Thread(this);
            UIThread.start();
        }
    }
 
    public void pauseApp() {
    }
 
    public void destroyApp(boolean unconditional) {
        // Make the event loop exit in the eSWT UI thread.
        exitEventLoop();
        // Wait for the eSWT UI thread to die. 
        try {
            UIThread.join();
        } catch(InterruptedException e) {
        }
    }
 
    void exitEventLoop() {
        exiting = true;
        Display.getDefault().wake();
    }
    
    /**************************************************************************
     * MIDLET End
     *************************************************************************/
    
    private void clearBtnStatus() {
		btnStatus03 = 0;
		btnStatus06 = 0;
	}
    
    // 사용자 정의 특수 문자 File Load
    private boolean loadSPKeySetting() {
    	
    	try {
	    	FileConnection fc = (FileConnection)Connector.open("file:///e:/data/ez_spkey.cfg", Connector.READ);
    		
	    	int bufferSize = (int)fc.fileSize();
	    	byte[] b = new byte[bufferSize];
	    	
	    	InputStream istream = fc.openInputStream();
	    	istream.read(b, 0, bufferSize);
	    		    	
	    	int count = 0;
	    	int index = 0;
	    	StringBuffer sb = new StringBuffer();
	    	
	    	boolean isUnicode = false;
	    	
	    	for (int i=3; i < bufferSize; i++) {
	    		
	    		if (b[i] == 9) {	// TAB	    			
	    			if (count == 1) {
   				
	    				if (isUnicode) {
		    				byte[] tmp = new byte[sb.length()];
		    				
		    				for (int ii=0; ii < sb.length(); ii++) {
		    					tmp[ii] = (byte)sb.charAt(ii);
		    				}
		    				
		    				spKeyTitle[index] = new String(tmp, "UTF-8");
			    			tmp = null;
			    			isUnicode = false;
		    				sb.setLength(0);
		    				count = 0;
		    			}
		    			else {
		    				spKeyTitle[index] = sb.toString();
		    				sb.setLength(0);
		    				count = 0;
		    			}
	    			}
	    			else {
	    				count++;
	    				sb.setLength(0);
	    			}
	    		}
	    		else if (b[i] == 13) {	// CRLF: 13 10
	    			if (isUnicode) {
	    				byte[] tmp = new byte[sb.length()];
	    				
	    				for (int ii=0; ii < sb.length(); ii++) {
	    					tmp[ii] = (byte)sb.charAt(ii);
	    				}
	    				
		    			spKeyString[index] = new String(tmp, "UTF-8");
		    			tmp = null;
		    			isUnicode = false;
	    				sb.setLength(0);
	    				index++;
	    			}
	    			else {
	    				spKeyString[index] = sb.toString();
	    				sb.setLength(0);
	    				index++;
	    			}
	    		}
	    		else if (b[i] == 10) {
	    			;
	    		}
	    		else if (b[i] < 0) {
	    			isUnicode = true;
	    			sb.append((char)b[i]);
	    		}
	    		else {
	    			sb.append((char)b[i]);
	    		}
	    	}
	    	
	    	sb = null;
	    	b = null;
	    	
//	    	for (int i=0; i < spKeyTitle.length; i++) {
//	    		System.out.println(i + "- " + spKeyTitle[i] + ": " + spKeyString[i]);
//	    	}
	      
	    } catch (IOException e) {
	        System.err.println(e); 
	        return false;
	    }
    	
    	return true;
    }
 
    // The eSWT UI Thread. 
    public void run() {
    	
    	amKR = new AutomataKR();
    	
		inputMode = 'K';		
		lastInput = 0;
		clearBtnStatus();
		
		spKeyTitle = new String[50];
		spKeyString = new String[50];
		
		if (!loadSPKeySetting())
			exitEventLoop();				

    	setUI();
    	
        // Execute the eSWT event loop. 
        while(!exiting) {
            if(!display.readAndDispatch()) {
                display.sleep();
            }
        }
 
        // Clean up and destroy the MIDlet.
        display.dispose();
        notifyDestroyed();
    }
    
    private void setUI() {
    	
    	display = new Display();
    	
    	Font font = display.getSystemFont();
    	FontData[] fd = font.getFontData();
    	
    	// 폰트 크기 설정
    	fd[0].setHeight(14);
    	bigFont01 = new Font(display, fd[0]);
    	
    	fd[0].setHeight(9);
    	bigFont02 = new Font(display, fd[0]);
    	
    	fd[0].setHeight(6);
    	smallFont = new Font(display, fd[0]);

    	font = null; 	
    	fd = null;
    	
    	cb = new Clipboard(display);							// 클립보드
		screens = MobileDevice.getMobileDevice().getScreens();	// landscape 설정
    	
        ezhShell = new MobileShell(display, SWT.CENTER);
        ezhShell.setFullScreenMode(true);
        
        qwertyShell = new MobileShell(display, SWT.CENTER);
        qwertyShell.setFullScreenMode(true);
        
        ezhETCButton06 = new Button(ezhShell, SWT.PUSH);
        ezhETCButton06.setSize(86, 45);
        ezhETCButton06.setLocation(5, 5);
        ezhETCButton06.addMouseListener(this);
        
        ezhETCButton07 = new Button(ezhShell, SWT.PUSH);
        ezhETCButton07.setSize(86, 45);
        ezhETCButton07.setLocation(93, 5);
        ezhETCButton07.addMouseListener(this);
        
        ezhETCButton08 = new Button(ezhShell, SWT.PUSH);
        ezhETCButton08.setSize(43, 45);
        ezhETCButton08.setLocation(181, 5);
        ezhETCButton08.addMouseListener(this);
        
        ezhETCButton09 = new Button(ezhShell, SWT.PUSH);
        ezhETCButton09.setSize(43, 45);
        ezhETCButton09.setLocation(226, 5);
        ezhETCButton09.addMouseListener(this);
        
        // 상태 TextBox
        statusTextBox = new Text(ezhShell, SWT.SINGLE | SWT.RIGHT);
        statusTextBox.setSize(86, 45);
        statusTextBox.setLocation(269, 5);
        
        // 입력 TextBox
        inputTextBox = new Text(ezhShell, SWT.MULTI | SWT.WRAP | SWT.BORDER | SWT.V_SCROLL);
        inputTextBox.setSize(350, 120);
        inputTextBox.setLocation(5, 55);
        inputTextBox.setEditable(false);
        inputTextBox.setFont(smallFont);
        
        ezhETCButton01 = new Button(ezhShell, SWT.PUSH);
        ezhETCButton01.setSize(69, 60);
        ezhETCButton01.setLocation(5, 180);
        ezhETCButton01.addMouseListener(this);
        
        ezhETCButton02 = new Button(ezhShell, SWT.PUSH);
        ezhETCButton02.setSize(69, 60);
        ezhETCButton02.setLocation(75, 180);
        ezhETCButton02.addMouseListener(this); 
        
        ezhETCButton03 = new Button(ezhShell, SWT.PUSH);
        ezhETCButton03.setSize(69, 60);
        ezhETCButton03.setLocation(145, 180);
        ezhETCButton03.addMouseListener(this); 
        
        ezhETCButton04 = new Button(ezhShell, SWT.PUSH);
        ezhETCButton04.setSize(69, 60);
        ezhETCButton04.setLocation(215, 180);
        ezhETCButton04.addMouseListener(this); 
        
        ezhETCButton05 = new Button(ezhShell, SWT.PUSH);
        ezhETCButton05.setSize(69, 60);
        ezhETCButton05.setLocation(285, 180);
        ezhETCButton05.addMouseListener(this); 
        
        // 이지한글 입력 버튼
        ezhButton01 = new Button(ezhShell, SWT.PUSH);
        ezhButton01.setSize(116, 90);
        ezhButton01.setLocation(5, 245);
        ezhButton01.addMouseListener(this);
        ezhButton01.setFont(bigFont01);
        
        ezhButton02 = new Button(ezhShell, SWT.PUSH);
        ezhButton02.setSize(116, 90);
        ezhButton02.setLocation(122, 245);
        ezhButton02.addMouseListener(this);
        ezhButton02.setFont(bigFont01);
        
        ezhButton03 = new Button(ezhShell, SWT.PUSH);
        ezhButton03.setSize(116, 90);
        ezhButton03.setLocation(239, 245);
        ezhButton03.addMouseListener(this);
        ezhButton03.setFont(bigFont01);
        
        //
        ezhButton04 = new Button(ezhShell, SWT.PUSH);
        ezhButton04.setSize(116, 90);
        ezhButton04.setLocation(5, 340);
        ezhButton04.addMouseListener(this);
        ezhButton04.setFont(bigFont01);
        
        ezhButton05 = new Button(ezhShell, SWT.PUSH);
        ezhButton05.setSize(116, 90);
        ezhButton05.setLocation(122, 340);
        ezhButton05.addMouseListener(this);
        ezhButton05.setFont(bigFont01);
        
        ezhButton06 = new Button(ezhShell, SWT.PUSH);
        ezhButton06.setSize(116, 90);
        ezhButton06.setLocation(239, 340);
        ezhButton06.addMouseListener(this);
        ezhButton06.setFont(bigFont01);
        
        //
        ezhButton07 = new Button(ezhShell, SWT.PUSH);
        ezhButton07.setSize(116, 90);
        ezhButton07.setLocation(5, 435);
        ezhButton07.addMouseListener(this);
        ezhButton07.setFont(bigFont01);
        
        ezhButton08 = new Button(ezhShell, SWT.PUSH);
        ezhButton08.setSize(116, 90);
        ezhButton08.setLocation(122, 435);
        ezhButton08.addMouseListener(this);
        ezhButton08.setFont(bigFont01);
        
        ezhButton09 = new Button(ezhShell, SWT.PUSH);
        ezhButton09.setSize(116, 90);
        ezhButton09.setLocation(239, 435);
        ezhButton09.addMouseListener(this);
        ezhButton09.setFont(bigFont01);
        
        //
        ezhButton10 = new Button(ezhShell, SWT.PUSH);
        ezhButton10.setSize(116, 90);
        ezhButton10.setLocation(5, 530);
        ezhButton10.addMouseListener(this);
        ezhButton10.setFont(bigFont01);
        
        ezhButton11 = new Button(ezhShell, SWT.PUSH);
        ezhButton11.setSize(116, 90);
        ezhButton11.setLocation(122, 530);
        ezhButton11.addMouseListener(this);
        ezhButton11.setFont(bigFont01);
        
        ezhButton12 = new Button(ezhShell, SWT.PUSH);
        ezhButton12.setSize(116, 90);
        ezhButton12.setLocation(239, 530);
        ezhButton12.addMouseListener(this);
        ezhButton12.setFont(bigFont01);
        
        // #############################################################
        // qwerty 키보드
        
        qtETCButton01 = new Button(qwertyShell, SWT.PUSH);
        qtETCButton01.setSize(70, 51);
        qtETCButton01.setLocation(5, 5);
        qtETCButton01.addMouseListener(this);
        
        qtETCButton02 = new Button(qwertyShell, SWT.PUSH);
        qtETCButton02.setSize(70, 51);
        qtETCButton02.setLocation(5, 58);
        qtETCButton02.addMouseListener(this);         
        
        // 입력 TextBox
        qtInputTextBox = new Text(qwertyShell, SWT.MULTI | SWT.WRAP | SWT.BORDER | SWT.V_SCROLL);
        qtInputTextBox.setSize(354, 104);
        qtInputTextBox.setLocation(77, 5);
        qtInputTextBox.setEditable(false);
        qtInputTextBox.setFont(smallFont);
        
        // 상태 TextBox
        qtStatusTextBox = new Text(qwertyShell, SWT.SINGLE | SWT.RIGHT);
        qtStatusTextBox.setSize(50, 51);
        qtStatusTextBox.setLocation(433, 5);
        qtStatusTextBox.setEditable(false);
        
        qtETCButton05 = new Button(qwertyShell, SWT.PUSH);
        qtETCButton05.setSize(70, 51);
        qtETCButton05.setLocation(485, 5);
        qtETCButton05.addMouseListener(this); 
        
        qtETCButton06 = new Button(qwertyShell, SWT.PUSH);
        qtETCButton06.setSize(70, 51);
        qtETCButton06.setLocation(485, 58);
        qtETCButton06.addMouseListener(this);
        
        qtETCButton03 = new Button(qwertyShell, SWT.PUSH);
        qtETCButton03.setSize(78, 51);
        qtETCButton03.setLocation(557, 5);
        qtETCButton03.addMouseListener(this); 
        
        qtETCButton04 = new Button(qwertyShell, SWT.PUSH);
        qtETCButton04.setSize(78, 51);
        qtETCButton04.setLocation(557, 58);
        qtETCButton04.addMouseListener(this);  
        
        //
        qwertyButton01 = new Button(qwertyShell, SWT.PUSH);
        qwertyButton01.setSize(62, 68);
        qwertyButton01.setLocation(5, 110);
        qwertyButton01.addMouseListener(this);
        qwertyButton01.setFont(bigFont02);
        
        qwertyButton02 = new Button(qwertyShell, SWT.PUSH);
        qwertyButton02.setSize(62, 68);
        qwertyButton02.setLocation(68, 110);
        qwertyButton02.addMouseListener(this);
        qwertyButton02.setFont(bigFont02);
        
        qwertyButton03 = new Button(qwertyShell, SWT.PUSH);
        qwertyButton03.setSize(62, 68);
        qwertyButton03.setLocation(131, 110);
        qwertyButton03.addMouseListener(this);
        qwertyButton03.setFont(bigFont02);
        
        qwertyButton04 = new Button(qwertyShell, SWT.PUSH);
        qwertyButton04.setSize(62, 68);
        qwertyButton04.setLocation(194, 110);
        qwertyButton04.addMouseListener(this);
        qwertyButton04.setFont(bigFont02);
        
        qwertyButton05 = new Button(qwertyShell, SWT.PUSH);
        qwertyButton05.setSize(62, 68);
        qwertyButton05.setLocation(257, 110);
        qwertyButton05.addMouseListener(this);
        qwertyButton05.setFont(bigFont02);
        
        qwertyButton06 = new Button(qwertyShell, SWT.PUSH);
        qwertyButton06.setSize(62, 68);
        qwertyButton06.setLocation(320, 110);
        qwertyButton06.addMouseListener(this);
        qwertyButton06.setFont(bigFont02);
        
        qwertyButton07 = new Button(qwertyShell, SWT.PUSH);
        qwertyButton07.setSize(62, 68);
        qwertyButton07.setLocation(383, 110);
        qwertyButton07.addMouseListener(this);
        qwertyButton07.setFont(bigFont02);
        
        qwertyButton08 = new Button(qwertyShell, SWT.PUSH);
        qwertyButton08.setSize(62, 68);
        qwertyButton08.setLocation(446, 110);
        qwertyButton08.addMouseListener(this);
        qwertyButton08.setFont(bigFont02);
        
        qwertyButton09 = new Button(qwertyShell, SWT.PUSH);
        qwertyButton09.setSize(62, 68);
        qwertyButton09.setLocation(509, 110);
        qwertyButton09.addMouseListener(this);
        qwertyButton09.setFont(bigFont02);
        
        qwertyButton10 = new Button(qwertyShell, SWT.PUSH);
        qwertyButton10.setSize(62, 68);
        qwertyButton10.setLocation(572, 110);
        qwertyButton10.addMouseListener(this);
        qwertyButton10.setFont(bigFont02);
        
        qwertyButton11 = new Button(qwertyShell, SWT.PUSH);
        qwertyButton11.setSize(62, 68);
        qwertyButton11.setLocation(5, 180);
        qwertyButton11.addMouseListener(this);
        qwertyButton11.setFont(bigFont02);
        
        qwertyButton12 = new Button(qwertyShell, SWT.PUSH);
        qwertyButton12.setSize(62, 68);
        qwertyButton12.setLocation(68, 180);
        qwertyButton12.addMouseListener(this);
        qwertyButton12.setFont(bigFont02);
        
        qwertyButton13 = new Button(qwertyShell, SWT.PUSH);
        qwertyButton13.setSize(62, 68);
        qwertyButton13.setLocation(131, 180);
        qwertyButton13.addMouseListener(this);
        qwertyButton13.setFont(bigFont02);
        
        qwertyButton14 = new Button(qwertyShell, SWT.PUSH);
        qwertyButton14.setSize(62, 68);
        qwertyButton14.setLocation(194, 180);
        qwertyButton14.addMouseListener(this);
        qwertyButton14.setFont(bigFont02);
        
        qwertyButton15 = new Button(qwertyShell, SWT.PUSH);
        qwertyButton15.setSize(62, 68);
        qwertyButton15.setLocation(257, 180);
        qwertyButton15.addMouseListener(this);
        qwertyButton15.setFont(bigFont02);
        
        qwertyButton16 = new Button(qwertyShell, SWT.PUSH);
        qwertyButton16.setSize(62, 68);
        qwertyButton16.setLocation(320, 180);
        qwertyButton16.addMouseListener(this);
        qwertyButton16.setFont(bigFont02);
        
        qwertyButton17 = new Button(qwertyShell, SWT.PUSH);
        qwertyButton17.setSize(62, 68);
        qwertyButton17.setLocation(383, 180);
        qwertyButton17.addMouseListener(this);
        qwertyButton17.setFont(bigFont02);
        
        qwertyButton18 = new Button(qwertyShell, SWT.PUSH);
        qwertyButton18.setSize(62, 68);
        qwertyButton18.setLocation(446, 180);
        qwertyButton18.addMouseListener(this);
        qwertyButton18.setFont(bigFont02);
        
        qwertyButton19 = new Button(qwertyShell, SWT.PUSH);
        qwertyButton19.setSize(62, 68);
        qwertyButton19.setLocation(509, 180);
        qwertyButton19.addMouseListener(this);
        qwertyButton19.setFont(bigFont02);
        
        qwertyButton20 = new Button(qwertyShell, SWT.PUSH);
        qwertyButton20.setSize(62, 68);
        qwertyButton20.setLocation(572, 180);
        qwertyButton20.addMouseListener(this);
        qwertyButton20.setFont(bigFont02);
        
        qwertyButton21 = new Button(qwertyShell, SWT.PUSH);
        qwertyButton21.setSize(62, 68);
        qwertyButton21.setLocation(5, 250);
        qwertyButton21.addMouseListener(this);
        qwertyButton21.setFont(bigFont02);
        
        qwertyButton22 = new Button(qwertyShell, SWT.PUSH);
        qwertyButton22.setSize(62, 68);
        qwertyButton22.setLocation(68, 250);
        qwertyButton22.addMouseListener(this);
        qwertyButton22.setFont(bigFont02);
        
        qwertyButton23 = new Button(qwertyShell, SWT.PUSH);
        qwertyButton23.setSize(62, 68);
        qwertyButton23.setLocation(131, 250);
        qwertyButton23.addMouseListener(this);
        qwertyButton23.setFont(bigFont02);
        
        qwertyButton24 = new Button(qwertyShell, SWT.PUSH);
        qwertyButton24.setSize(62, 68);
        qwertyButton24.setLocation(194, 250);
        qwertyButton24.addMouseListener(this);
        qwertyButton24.setFont(bigFont02);
        
        qwertyButton25 = new Button(qwertyShell, SWT.PUSH);
        qwertyButton25.setSize(62, 68);
        qwertyButton25.setLocation(257, 250);
        qwertyButton25.addMouseListener(this);
        qwertyButton25.setFont(bigFont02);
        
        qwertyButton26 = new Button(qwertyShell, SWT.PUSH);
        qwertyButton26.setSize(62, 68);
        qwertyButton26.setLocation(320, 250);
        qwertyButton26.addMouseListener(this);
        qwertyButton26.setFont(bigFont02);
        
        qwertyButton27 = new Button(qwertyShell, SWT.PUSH);
        qwertyButton27.setSize(62, 68);
        qwertyButton27.setLocation(383, 250);
        qwertyButton27.addMouseListener(this);
        qwertyButton27.setFont(bigFont02);
        
        qwertyButton28 = new Button(qwertyShell, SWT.PUSH);
        qwertyButton28.setSize(62, 68);
        qwertyButton28.setLocation(446, 250);
        qwertyButton28.addMouseListener(this);
        qwertyButton28.setFont(bigFont02);
        
        qwertyButton29 = new Button(qwertyShell, SWT.PUSH);
        qwertyButton29.setSize(62, 68);
        qwertyButton29.setLocation(509, 250);
        qwertyButton29.addMouseListener(this);
        qwertyButton29.setFont(bigFont02);
        
        qwertyButton30 = new Button(qwertyShell, SWT.PUSH);
        qwertyButton30.setSize(62, 68);
        qwertyButton30.setLocation(572, 250);
        qwertyButton30.addMouseListener(this);
        qwertyButton30.setFont(bigFont02);
        
        ///////////////////////////////////////////////
        qwertyButton31 = new Button(qwertyShell, SWT.PUSH);
        qwertyButton31.setSize(125, 38);
        qwertyButton31.setLocation(5, 320);
        qwertyButton31.addMouseListener(this);
        
        qwertyButton32 = new Button(qwertyShell, SWT.PUSH);
        qwertyButton32.setSize(125, 38);
        qwertyButton32.setLocation(131, 320);
        qwertyButton32.addMouseListener(this);
                
        qwertyButton33 = new Button(qwertyShell, SWT.PUSH);
        qwertyButton33.setSize(125, 38);
        qwertyButton33.setLocation(257, 320);
        qwertyButton33.addMouseListener(this);
                
        qwertyButton34 = new Button(qwertyShell, SWT.PUSH);
        qwertyButton34.setSize(125, 38);
        qwertyButton34.setLocation(383, 320);
        qwertyButton34.addMouseListener(this);
        
        qwertyButton35 = new Button(qwertyShell, SWT.PUSH);
        qwertyButton35.setSize(125, 38);
        qwertyButton35.setLocation(509, 320);
        qwertyButton35.addMouseListener(this);
        
        setEZHangul();
        setQwertyCommon();
        setQwertyHangul();
        
        setSpecialButton();
        deactiveSpecialKey();
        
        ezhShell.open();
        qwertyShell.open();
        
        if (spKeyString[48].equalsIgnoreCase("e"))
        	ezhShell.setActive();
        else if (spKeyString[48].equalsIgnoreCase("q")) {
        	isQwerty = true;
        	screens[0].setOrientation(Screen.LANDSCAPE);
        	qwertyShell.setActive();
        }
        else {
        	exitEventLoop();
        }
        	
    }
    
    // 이지한글 셋팅
    private void setEZHangul() {
        ezhETCButton06.setText("Copy");
        ezhETCButton07.setText("QWER");
        ezhETCButton08.setText("_");
        ezhETCButton09.setText("X");
        ezhETCButton01.setText("123");
        ezhETCButton02.setText("");
        ezhETCButton03.setText("clr");
        ezhETCButton04.setText("bs");
        ezhETCButton05.setText("sp");
        ezhButton01.setText("ㄱ");
        ezhButton02.setText("ㄴ");
        ezhButton03.setText("ㅏㅓ");
        ezhButton04.setText("ㄹ");
        ezhButton05.setText("ㅁ");
        ezhButton06.setText("ㅗㅜ");
        ezhButton07.setText("ㅅ");
        ezhButton08.setText("ㅇ");
        ezhButton09.setText("ㅣ");
        ezhButton10.setText("*");
        ezhButton11.setText("ㅡ");
        ezhButton12.setText("#");
    }
    
    private void setSpecialButton() {
    	// 특수문자 입력키 셋팅
        ezhSpecialButton01 = new Button(ezhShell, SWT.PUSH);
        ezhSpecialButton01.setSize(86, 60);
        ezhSpecialButton01.setLocation(5, 245);
        ezhSpecialButton01.addMouseListener(this);
        
        ezhSpecialButton02 = new Button(ezhShell, SWT.PUSH);
        ezhSpecialButton02.setSize(86, 60);
        ezhSpecialButton02.setLocation(93, 245);
        ezhSpecialButton02.addMouseListener(this); 
        
        ezhSpecialButton03 = new Button(ezhShell, SWT.PUSH);
        ezhSpecialButton03.setSize(86, 60);
        ezhSpecialButton03.setLocation(181, 245);
        ezhSpecialButton03.addMouseListener(this); 
        
        ezhSpecialButton04 = new Button(ezhShell, SWT.PUSH);
        ezhSpecialButton04.setSize(86, 60);
        ezhSpecialButton04.setLocation(269, 245);
        ezhSpecialButton04.addMouseListener(this); 
        
        //
        ezhSpecialButton05 = new Button(ezhShell, SWT.PUSH);
        ezhSpecialButton05.setSize(86, 60);
        ezhSpecialButton05.setLocation(5, 310);
        ezhSpecialButton05.addMouseListener(this); 
        
        ezhSpecialButton06 = new Button(ezhShell, SWT.PUSH);
        ezhSpecialButton06.setSize(86, 60);
        ezhSpecialButton06.setLocation(93, 310);
        ezhSpecialButton06.addMouseListener(this); 
        
        ezhSpecialButton07 = new Button(ezhShell, SWT.PUSH);
        ezhSpecialButton07.setSize(86, 60);
        ezhSpecialButton07.setLocation(181, 310);
        ezhSpecialButton07.addMouseListener(this); 
        
        ezhSpecialButton08 = new Button(ezhShell, SWT.PUSH);
        ezhSpecialButton08.setSize(86, 60);
        ezhSpecialButton08.setLocation(269, 310);
        ezhSpecialButton08.addMouseListener(this); 
        
        //
        ezhSpecialButton09 = new Button(ezhShell, SWT.PUSH);
        ezhSpecialButton09.setSize(86, 60);
        ezhSpecialButton09.setLocation(5, 375);
        ezhSpecialButton09.addMouseListener(this); 
        
        ezhSpecialButton10 = new Button(ezhShell, SWT.PUSH);
        ezhSpecialButton10.setSize(86, 60);
        ezhSpecialButton10.setLocation(93, 375);
        ezhSpecialButton10.addMouseListener(this); 
        
        ezhSpecialButton11 = new Button(ezhShell, SWT.PUSH);
        ezhSpecialButton11.setSize(86, 60);
        ezhSpecialButton11.setLocation(181, 375);
        ezhSpecialButton11.addMouseListener(this); 
        
        ezhSpecialButton12 = new Button(ezhShell, SWT.PUSH);
        ezhSpecialButton12.setSize(86, 60);
        ezhSpecialButton12.setLocation(269, 375);
        ezhSpecialButton12.addMouseListener(this);
        
        //
        ezhSpecialButton13 = new Button(ezhShell, SWT.PUSH);
        ezhSpecialButton13.setSize(86, 60);
        ezhSpecialButton13.setLocation(5, 440);
        ezhSpecialButton13.addMouseListener(this); 
        
        ezhSpecialButton14 = new Button(ezhShell, SWT.PUSH);
        ezhSpecialButton14.setSize(86, 60);
        ezhSpecialButton14.setLocation(93, 440);
        ezhSpecialButton14.addMouseListener(this);
        
        ezhSpecialButton15 = new Button(ezhShell, SWT.PUSH);
        ezhSpecialButton15.setSize(86, 60);
        ezhSpecialButton15.setLocation(181, 440);
        ezhSpecialButton15.addMouseListener(this);
        
        ezhSpecialButton16 = new Button(ezhShell, SWT.PUSH);
        ezhSpecialButton16.setSize(86, 60);
        ezhSpecialButton16.setLocation(269, 440);
        ezhSpecialButton16.addMouseListener(this);
        
        //
        ezhSpecialButton17 = new Button(ezhShell, SWT.PUSH);
        ezhSpecialButton17.setSize(86, 60);
        ezhSpecialButton17.setLocation(5, 505);
        ezhSpecialButton17.addMouseListener(this);
        
        ezhSpecialButton18 = new Button(ezhShell, SWT.PUSH);
        ezhSpecialButton18.setSize(86, 60);
        ezhSpecialButton18.setLocation(93, 505);
        ezhSpecialButton18.addMouseListener(this);
        
        ezhSpecialButton19 = new Button(ezhShell, SWT.PUSH);
        ezhSpecialButton19.setSize(86, 60);
        ezhSpecialButton19.setLocation(181, 505);
        ezhSpecialButton19.addMouseListener(this);
        
        ezhSpecialButton20 = new Button(ezhShell, SWT.PUSH);
        ezhSpecialButton20.setSize(86, 60);
        ezhSpecialButton20.setLocation(269, 505);
        ezhSpecialButton20.addMouseListener(this);
        
        //
        ezhSpecialButton21 = new Button(ezhShell, SWT.PUSH);
        ezhSpecialButton21.setSize(86, 60);
        ezhSpecialButton21.setLocation(5, 570);
        ezhSpecialButton21.addMouseListener(this);
        
        ezhSpecialButton22 = new Button(ezhShell, SWT.PUSH);
        ezhSpecialButton22.setSize(86, 60);
        ezhSpecialButton22.setLocation(93, 570);
        ezhSpecialButton22.addMouseListener(this);
        
        ezhSpecialButton23 = new Button(ezhShell, SWT.PUSH);
        ezhSpecialButton23.setSize(86, 60);
        ezhSpecialButton23.setLocation(181, 570);
        ezhSpecialButton23.addMouseListener(this);
        
        ezhSpecialButton24 = new Button(ezhShell, SWT.PUSH);
        ezhSpecialButton24.setSize(86, 60);
        ezhSpecialButton24.setLocation(269, 570);
        ezhSpecialButton24.addMouseListener(this);
    }
    
    private void setSpecialKeyText01() {
        ezhSpecialButton01.setText(spKeyTitle[0]);
        ezhSpecialButton02.setText(spKeyTitle[1]);
        ezhSpecialButton03.setText(spKeyTitle[2]);
        ezhSpecialButton04.setText(spKeyTitle[3]);
        ezhSpecialButton05.setText(spKeyTitle[4]);
        ezhSpecialButton06.setText(spKeyTitle[5]);
        ezhSpecialButton07.setText(spKeyTitle[6]);
        ezhSpecialButton08.setText(spKeyTitle[7]);
        ezhSpecialButton09.setText(spKeyTitle[8]);
        ezhSpecialButton10.setText(spKeyTitle[9]);
        ezhSpecialButton11.setText(spKeyTitle[10]);
        ezhSpecialButton12.setText(spKeyTitle[11]);
        ezhSpecialButton13.setText(spKeyTitle[12]);
        ezhSpecialButton14.setText(spKeyTitle[13]);
        ezhSpecialButton15.setText(spKeyTitle[14]);
        ezhSpecialButton16.setText(spKeyTitle[15]);
        ezhSpecialButton17.setText(spKeyTitle[16]);
        ezhSpecialButton18.setText(spKeyTitle[17]);
        ezhSpecialButton19.setText(spKeyTitle[18]);
        ezhSpecialButton20.setText(spKeyTitle[19]);
        ezhSpecialButton21.setText(spKeyTitle[20]);
        ezhSpecialButton22.setText(spKeyTitle[21]);
        ezhSpecialButton23.setText(spKeyTitle[22]);
        ezhSpecialButton24.setText(spKeyTitle[23]);
    }
    
    private void setSpecialKeyText02() {
        ezhSpecialButton01.setText(spKeyTitle[24]);
        ezhSpecialButton02.setText(spKeyTitle[25]);
        ezhSpecialButton03.setText(spKeyTitle[26]);
        ezhSpecialButton04.setText(spKeyTitle[27]);
        ezhSpecialButton05.setText(spKeyTitle[28]);
        ezhSpecialButton06.setText(spKeyTitle[29]);
        ezhSpecialButton07.setText(spKeyTitle[30]);
        ezhSpecialButton08.setText(spKeyTitle[31]);
        ezhSpecialButton09.setText(spKeyTitle[32]);
        ezhSpecialButton10.setText(spKeyTitle[33]);
        ezhSpecialButton11.setText(spKeyTitle[34]);
        ezhSpecialButton12.setText(spKeyTitle[35]);
        ezhSpecialButton13.setText(spKeyTitle[36]);
        ezhSpecialButton14.setText(spKeyTitle[37]);
        ezhSpecialButton15.setText(spKeyTitle[38]);
        ezhSpecialButton16.setText(spKeyTitle[39]);
        ezhSpecialButton17.setText(spKeyTitle[40]);
        ezhSpecialButton18.setText(spKeyTitle[41]);
        ezhSpecialButton19.setText(spKeyTitle[42]);
        ezhSpecialButton20.setText(spKeyTitle[43]);
        ezhSpecialButton21.setText(spKeyTitle[44]);
        ezhSpecialButton22.setText(spKeyTitle[45]);
        ezhSpecialButton23.setText(spKeyTitle[46]);
        ezhSpecialButton24.setText(spKeyTitle[47]);
    }
    
    private void setQwertyCommon() {
    	qtETCButton01.setText("EZH");
        qtETCButton02.setText("Copy");
        qtETCButton03.setText("Clear");
        qtETCButton04.setText("bs");
        qtETCButton05.setText("_");
        qtETCButton06.setText("X");
        
        qwertyButton31.setText("Shift Off");
        qwertyButton32.setText("ABC");
        qwertyButton33.setText("");
        qwertyButton34.setText("Space");
        qwertyButton35.setText("Enter");
    }
    
    private void setQwertyHangul() {
        
        qwertyButton01.setText("ㅂ");
        qwertyButton02.setText("ㅈ");
        qwertyButton03.setText("ㄷ");
        qwertyButton04.setText("ㄱ");
        qwertyButton05.setText("ㅅ");
        qwertyButton06.setText("ㅛ");
        qwertyButton07.setText("ㅕ");
        qwertyButton08.setText("ㅑ");
        qwertyButton09.setText("ㅐ");
        qwertyButton10.setText("ㅔ");
        
        qwertyButton11.setText("ㅁ");
        qwertyButton12.setText("ㄴ");
        qwertyButton13.setText("ㅇ");
        qwertyButton14.setText("ㄹ");
        qwertyButton15.setText("ㅎ");
        qwertyButton16.setText("ㅗ");
        qwertyButton17.setText("ㅓ");
        qwertyButton18.setText("ㅏ");
        qwertyButton19.setText("ㅣ");
        qwertyButton20.setText("'");
        
        qwertyButton21.setText("ㅋ");
        qwertyButton22.setText("ㅌ");
        qwertyButton23.setText("ㅊ");
        qwertyButton24.setText("ㅍ");
        qwertyButton25.setText("ㅠ");
        qwertyButton26.setText("ㅜ");
        qwertyButton27.setText("ㅡ");
        qwertyButton28.setText(",");
        qwertyButton29.setText(".");      
        qwertyButton30.setText("?");
    }
    
    private void setQwertyAlphabetUpper() {
        qwertyButton01.setText("Q");
        qwertyButton02.setText("W");
        qwertyButton03.setText("E");
        qwertyButton04.setText("R");
        qwertyButton05.setText("T");
        qwertyButton06.setText("Y");
        qwertyButton07.setText("U");
        qwertyButton08.setText("I");
        qwertyButton09.setText("O");
        qwertyButton10.setText("P");
        
        qwertyButton11.setText("A");
        qwertyButton12.setText("S");
        qwertyButton13.setText("D");
        qwertyButton14.setText("F");
        qwertyButton15.setText("G");
        qwertyButton16.setText("H");
        qwertyButton17.setText("J");
        qwertyButton18.setText("K");
        qwertyButton19.setText("L");
        qwertyButton20.setText("/");
        
        qwertyButton21.setText("Z");
        qwertyButton22.setText("X");
        qwertyButton23.setText("C");
        qwertyButton24.setText("V");
        qwertyButton25.setText("B");
        qwertyButton26.setText("N");
        qwertyButton27.setText("M");
        qwertyButton28.setText("+");
        qwertyButton29.setText("-");
        qwertyButton30.setText("!");
    }
    
    private void setQwertyAlphabetLower() {
        qwertyButton01.setText("q");
        qwertyButton02.setText("w");
        qwertyButton03.setText("e");
        qwertyButton04.setText("r");
        qwertyButton05.setText("t");
        qwertyButton06.setText("y");
        qwertyButton07.setText("u");
        qwertyButton08.setText("i");
        qwertyButton09.setText("o");
        qwertyButton10.setText("p");
        
        qwertyButton11.setText("a");
        qwertyButton12.setText("s");
        qwertyButton13.setText("d");
        qwertyButton14.setText("f");
        qwertyButton15.setText("g");
        qwertyButton16.setText("h");
        qwertyButton17.setText("j");
        qwertyButton18.setText("k");
        qwertyButton19.setText("l");
        qwertyButton20.setText("'");
        
        qwertyButton21.setText("z");
        qwertyButton22.setText("x");
        qwertyButton23.setText("c");
        qwertyButton24.setText("v");
        qwertyButton25.setText("b");
        qwertyButton26.setText("n");
        qwertyButton27.setText("m");
        qwertyButton28.setText(",");
        qwertyButton29.setText(".");      
        qwertyButton30.setText("?");
    }
    
    private void setQwertySpecialKey() {
        qwertyButton01.setText(spKeyTitle[0]);
        qwertyButton02.setText(spKeyTitle[1]);
        qwertyButton03.setText(spKeyTitle[2]);
        qwertyButton04.setText(spKeyTitle[3]);
        qwertyButton05.setText(spKeyTitle[4]);
        qwertyButton06.setText(spKeyTitle[5]);
        qwertyButton07.setText(spKeyTitle[6]);
        qwertyButton08.setText(spKeyTitle[7]);
        qwertyButton09.setText(spKeyTitle[8]);
        qwertyButton10.setText(spKeyTitle[9]);
        
        qwertyButton11.setText(spKeyTitle[10]);
        qwertyButton12.setText(spKeyTitle[11]);
        qwertyButton13.setText(spKeyTitle[12]);
        qwertyButton14.setText(spKeyTitle[13]);
        qwertyButton15.setText(spKeyTitle[14]);
        qwertyButton16.setText(spKeyTitle[15]);
        qwertyButton17.setText(spKeyTitle[16]);
        qwertyButton18.setText(spKeyTitle[17]);
        qwertyButton19.setText(spKeyTitle[18]);
        qwertyButton20.setText(spKeyTitle[19]);
        
        qwertyButton21.setText(spKeyTitle[20]);
        qwertyButton22.setText(spKeyTitle[21]);
        qwertyButton23.setText(spKeyTitle[22]);
        qwertyButton24.setText(spKeyTitle[23]);
        qwertyButton25.setText(spKeyTitle[24]);
        qwertyButton26.setText(spKeyTitle[25]);
        qwertyButton27.setText(spKeyTitle[26]);
        qwertyButton28.setText(spKeyTitle[27]);
        qwertyButton29.setText(spKeyTitle[28]);
        qwertyButton30.setText(spKeyTitle[29]);
    }
    
    private void activeSpecialKey() {
    	// 한글 입력키 비활성화
    	ezhButton01.setVisible(false);
        ezhButton02.setVisible(false);
        ezhButton03.setVisible(false);
        ezhButton04.setVisible(false);
        ezhButton05.setVisible(false);
        ezhButton06.setVisible(false);
        ezhButton07.setVisible(false);
        ezhButton08.setVisible(false);
        ezhButton09.setVisible(false);
        ezhButton10.setVisible(false);
        ezhButton11.setVisible(false);
        ezhButton12.setVisible(false);
        
        ezhSpecialButton01.setVisible(true);
        ezhSpecialButton02.setVisible(true);
        ezhSpecialButton03.setVisible(true);
        ezhSpecialButton04.setVisible(true);
        ezhSpecialButton05.setVisible(true);
        ezhSpecialButton06.setVisible(true);
        ezhSpecialButton07.setVisible(true);
        ezhSpecialButton08.setVisible(true);
        ezhSpecialButton09.setVisible(true);
        ezhSpecialButton10.setVisible(true);
        ezhSpecialButton11.setVisible(true);
        ezhSpecialButton12.setVisible(true);
        ezhSpecialButton13.setVisible(true);
        ezhSpecialButton14.setVisible(true);
        ezhSpecialButton15.setVisible(true);
        ezhSpecialButton16.setVisible(true);
        ezhSpecialButton17.setVisible(true);
        ezhSpecialButton18.setVisible(true);
        ezhSpecialButton19.setVisible(true);
        ezhSpecialButton20.setVisible(true);
        ezhSpecialButton21.setVisible(true);
        ezhSpecialButton22.setVisible(true);
        ezhSpecialButton23.setVisible(true);
        ezhSpecialButton24.setVisible(true);
    }
    
    private void deactiveSpecialKey() {
    	// 한글 입력키 활성화
    	ezhButton01.setVisible(true);
        ezhButton02.setVisible(true);
        ezhButton03.setVisible(true);
        ezhButton04.setVisible(true);
        ezhButton05.setVisible(true);
        ezhButton06.setVisible(true);
        ezhButton07.setVisible(true);
        ezhButton08.setVisible(true);
        ezhButton09.setVisible(true);
        ezhButton10.setVisible(true);
        ezhButton11.setVisible(true);
        ezhButton12.setVisible(true);
        
        ezhSpecialButton01.setVisible(false);
        ezhSpecialButton02.setVisible(false);
        ezhSpecialButton03.setVisible(false);
        ezhSpecialButton04.setVisible(false);
        ezhSpecialButton05.setVisible(false);
        ezhSpecialButton06.setVisible(false);
        ezhSpecialButton07.setVisible(false);
        ezhSpecialButton08.setVisible(false);
        ezhSpecialButton09.setVisible(false);
        ezhSpecialButton10.setVisible(false);
        ezhSpecialButton11.setVisible(false);
        ezhSpecialButton12.setVisible(false);
        ezhSpecialButton13.setVisible(false);
        ezhSpecialButton14.setVisible(false);
        ezhSpecialButton15.setVisible(false);
        ezhSpecialButton16.setVisible(false);
        ezhSpecialButton17.setVisible(false);
        ezhSpecialButton18.setVisible(false);
        ezhSpecialButton19.setVisible(false);
        ezhSpecialButton20.setVisible(false);
        ezhSpecialButton21.setVisible(false);
        ezhSpecialButton22.setVisible(false);
        ezhSpecialButton23.setVisible(false);
        ezhSpecialButton24.setVisible(false);
    }
 
    private void activeQwertyShift() {
    	qwertyButton01.setText("ㅃ");
    	qwertyButton02.setText("ㅉ");
    	qwertyButton03.setText("ㄸ");
    	qwertyButton04.setText("ㄲ");
    	qwertyButton05.setText("ㅆ");
    	
    	qwertyButton09.setText("ㅒ");
    	qwertyButton10.setText("ㅖ");   
    	
    	qwertyButton20.setText("/");
        qwertyButton28.setText("+");
        qwertyButton29.setText("-");
        qwertyButton30.setText("!");
    }
    
    private void deactiveQwertyShift() {
    	qwertyButton01.setText("ㅂ");
    	qwertyButton02.setText("ㅈ");
    	qwertyButton03.setText("ㄷ");
    	qwertyButton04.setText("ㄱ");
    	qwertyButton05.setText("ㅅ");
    	
    	qwertyButton09.setText("ㅐ");
    	qwertyButton10.setText("ㅔ"); 
    	
    	qwertyButton20.setText("'");
        qwertyButton28.setText(",");
        qwertyButton29.setText(".");      
        qwertyButton30.setText("?");
    }    
    
     // MouseListener
    public void mouseDoubleClick(MouseEvent arg0) {
		
	}

	public void mouseDown(MouseEvent arg0) {
		
	}
	
    public void mouseUp(MouseEvent arg0) {
    	
    	// 종료
    	if (arg0.widget.equals(ezhETCButton09) || arg0.widget.equals(qtETCButton06)) {
            exitEventLoop();        
        }
        
        // 클립보드에 복사
        else if (arg0.widget.equals(ezhETCButton06) || arg0.widget.equals(qtETCButton02)) {
        	if (amKR.getTextResult().length() > 0) {
	        	textTransfer = TextTransfer.getInstance();
	    		cb.setContents(new Object[]{amKR.getTextResult()}, new Transfer[]{textTransfer}); 
        	}
        }
        
        // 쿼티 키보드로 변경
        else if (arg0.widget.equals(ezhETCButton07)) {
        	isQwerty = true;
        	screens[0].setOrientation(Screen.LANDSCAPE);
        	qwertyShell.setActive();
        	
        	qtInputTextBox.setText(amKR.getTextResult());
        }
        
        // 입력기를 백그라운드로 보냄
        else if (arg0.widget.equals(ezhETCButton08) || arg0.widget.equals(qtETCButton05)) {
        	Shell activeShell = display.getActiveShell();

        	if (activeShell != null) {
	        	activeShell.setMinimized(true);
	        	activeShell = display.getActiveShell();
        	}
        }
        // 입력모드 변환
        else if (arg0.widget.equals(ezhETCButton01)) {
        	
        	switch (inputMode) {
        	case 'K':
        		isSpecialKey01 = true;
        		isSpecialKey02 = false;
        		isKorean = false;
        		activeSpecialKey();
        		setSpecialKeyText01();
        		
        		inputMode = 'S';
        		ezhETCButton01.setText("★");
        		break;        		
        	case 'S':
        		isSpecialKey01 = false;
        		isSpecialKey02 = true;
        		setSpecialKeyText02();
        		
        		inputMode = 'P';
        		ezhETCButton01.setText("KR");
        		break;
        	case 'P':
        		isSpecialKey02 = false;
        		isKorean = true;
        		deactiveSpecialKey();
        		
        		inputMode = 'K';        		
        		ezhETCButton01.setText("123");
        		break;
        	}
        }
        // 입력창 클리어
        else if (arg0.widget.equals(ezhETCButton03)) {        	

            if (spKeyString[49].equalsIgnoreCase("y")) {
	        	MessageBox mbox = new MessageBox(ezhShell, SWT.ICON_QUESTION | SWT.YES | SWT.NO);
	        	mbox.setMessage("Clear Text?");
	        	int result = mbox.open();
	        	 
	        	if (result == SWT.YES) {
	        		amKR.clearInputText();
	        		inputTextBox.setText("");
	        	}
            }
            else {
            	amKR.clearInputText();
        		inputTextBox.setText("");
            }
        }
        // 백스페이스
        else if (arg0.widget.equals(ezhETCButton04)) {
        	backspaceButton();
    		inputTextBox.setText(amKR.getTextResult());     		       	
        }
        // 스페이스
        else if (arg0.widget.equals(ezhETCButton05)) {
        	spaceButton();
    		inputTextBox.setText(amKR.getTextResult());    		       	
        }
    	
    	// 이지한글로 변경
        else if (arg0.widget.equals(qtETCButton01)) {
        	isQwerty = false;
        	screens[0].setOrientation(Screen.PORTRAIT);
        	ezhShell.setActive();  
        	
        	inputTextBox.setText(amKR.getTextResult());
        }
        // 입력창 클리어
        else if (arg0.widget.equals(qtETCButton03)) {    		
    		if (spKeyString[49].equalsIgnoreCase("y")) {
	        	MessageBox mbox = new MessageBox(qwertyShell, SWT.ICON_QUESTION | SWT.YES | SWT.NO);
	        	mbox.setMessage("Clear Text?");
	        	int result = mbox.open();
	        	 
	        	if (result == SWT.YES) {
	        		amKR.clearInputText();
	        		qtInputTextBox.setText("");
	        	}
            }
            else {
            	amKR.clearInputText();
            	qtInputTextBox.setText("");
            }
        }
        // 백스페이스
        else if (arg0.widget.equals(qtETCButton04)) {
        	backspaceButton();
    		qtInputTextBox.setText(amKR.getTextResult());     		       	
        }
        // Shift
        else if (arg0.widget.equals(qwertyButton31)) {
        	
        	if (isQwertyShift) {
        		if (isQwertyAlpha) {
        			if (isQwertyAlphaLower) { 
        				setQwertyAlphabetUpper();
        				isQwertyAlphaLower = false;
        			}
        			else {
        				setQwertyAlphabetLower();
        				isQwertyAlphaLower = true;
        			}        			
        		}
        		else if (isQwertySpkey) {
        			;
        		}
        		else {        			
        			deactiveQwertyShift();
        		}
        		
        		isQwertyShift = false;
        		qwertyButton31.setText("Shift Off");
        	}
        	else {
        		if (isQwertyAlpha) {
        			if (isQwertyAlphaLower) { 
        				setQwertyAlphabetUpper();
        				isQwertyAlphaLower = false;
        			}
        			else {
        				setQwertyAlphabetLower();
        				isQwertyAlphaLower = true;
        			}
        		}
        		else if (isQwertySpkey) {
        			;
        		}
        		else {
            		activeQwertyShift();
        		}
        		isQwertyShift = true;
        		qwertyButton31.setText("Shift On");
        	}
        }
        // 키보드 변환 (한글->영문->특수문자)
        else if (arg0.widget.equals(qwertyButton32)) {
        	
        	switch (qtInputMode) {
        	case 'K':
        		qtInputMode = 'A';
        		isQwertyAlpha = true;
        		isQwertyHangul = false;
        		isQwertySpkey = false;
        		isQwertyShift = false;
        		isQwertyAlphaLower = true;
        		setQwertyAlphabetLower();
        		qwertyButton32.setText("★");
        		break;
        	case 'A':
        		qtInputMode = 'S';
        		isQwertyAlpha = false;
        		isQwertyHangul = false;
        		isQwertySpkey = true;
        		isQwertyShift = false;
        		isQwertyAlphaLower = false;
        		setQwertySpecialKey();
        		qwertyButton32.setText("KR");
        		break;
        	case 'S':
        		qtInputMode = 'K';
        		isQwertyAlpha = false;
        		isQwertyHangul = true;
        		isQwertySpkey = false;
        		isQwertyShift = false;
        		isQwertyAlphaLower = false;
        		setQwertyHangul();
        		qwertyButton32.setText("ABC");
        		break;
        	}
        }   	
    	
    	// 이지한글인 경우
    	if (!isQwerty) {
    		if (isKorean) {
    	        
    	        if (arg0.widget.equals(ezhButton01)) {
    	        	inputButton01();
    	    		inputTextBox.setText(amKR.getTextResult());
    	        }
    	        else if (arg0.widget.equals(ezhButton02)) {
    	        	inputButton02();
    	    		inputTextBox.setText(amKR.getTextResult());    		       	
    	        }
    	        else if (arg0.widget.equals(ezhButton03)) {
    	        	inputButton03();
    	    		inputTextBox.setText(amKR.getTextResult());    		       	
    	        }
    	        else if (arg0.widget.equals(ezhButton04)) {
    	        	inputButton04();
    	    		inputTextBox.setText(amKR.getTextResult());    		       	
    	        }
    	        else if (arg0.widget.equals(ezhButton05)) {
    	        	inputButton05();
    	    		inputTextBox.setText(amKR.getTextResult());    		       	
    	        }
    	        else if (arg0.widget.equals(ezhButton06)) {
    	        	inputButton06();
    	    		inputTextBox.setText(amKR.getTextResult());    		       	
    	        }
    	        else if (arg0.widget.equals(ezhButton07)) {
    	        	inputButton07();
    	    		inputTextBox.setText(amKR.getTextResult());    		       	
    	        }
    	        else if (arg0.widget.equals(ezhButton08)) {
    	        	inputButton08();
    	    		inputTextBox.setText(amKR.getTextResult());    		       	
    	        }
    	        else if (arg0.widget.equals(ezhButton09)) {
    	        	inputButton09();
    	    		inputTextBox.setText(amKR.getTextResult());    		       	
    	        }
    	        else if (arg0.widget.equals(ezhButton10)) {
    	        	inputButton10();
    	    		inputTextBox.setText(amKR.getTextResult());    		       	
    	        }
    	        else if (arg0.widget.equals(ezhButton11)) {
    	        	inputButton11();
    	    		inputTextBox.setText(amKR.getTextResult());    		       	
    	        }
    	        else if (arg0.widget.equals(ezhButton12)) {
    	        	inputButton12();
    	    		inputTextBox.setText(amKR.getTextResult());    		       	
    	        }
        	}
        	else {
        		if (arg0.widget.equals(ezhSpecialButton01)) {
    	        	inputSPButton01();
    	    		inputTextBox.setText(amKR.getTextResult());    		       	
    	        }
    	        else if (arg0.widget.equals(ezhSpecialButton02)) {
    	        	inputSPButton02();
    	    		inputTextBox.setText(amKR.getTextResult());    		       	
    	        }
    	        else if (arg0.widget.equals(ezhSpecialButton03)) {
    	        	inputSPButton03();
    	    		inputTextBox.setText(amKR.getTextResult());    		       	
    	        }
    	        else if (arg0.widget.equals(ezhSpecialButton04)) {
    	        	inputSPButton04();
    	    		inputTextBox.setText(amKR.getTextResult());    		       	
    	        }
    	        else if (arg0.widget.equals(ezhSpecialButton05)) {
    	        	inputSPButton05();
    	    		inputTextBox.setText(amKR.getTextResult());    		       	
    	        }
    	        else if (arg0.widget.equals(ezhSpecialButton06)) {
    	        	inputSPButton06();
    	    		inputTextBox.setText(amKR.getTextResult());    		       	
    	        }
    	        else if (arg0.widget.equals(ezhSpecialButton07)) {
    	        	inputSPButton07();
    	    		inputTextBox.setText(amKR.getTextResult());    		       	
    	        }
    	        else if (arg0.widget.equals(ezhSpecialButton08)) {
    	        	inputSPButton08();
    	    		inputTextBox.setText(amKR.getTextResult());    		       	
    	        }
    	        else if (arg0.widget.equals(ezhSpecialButton09)) {
    	        	inputSPButton09();
    	    		inputTextBox.setText(amKR.getTextResult());    		       	
    	        }
    	        else if (arg0.widget.equals(ezhSpecialButton10)) {
    	        	inputSPButton10();
    	    		inputTextBox.setText(amKR.getTextResult());    		       	
    	        }
    	        else if (arg0.widget.equals(ezhSpecialButton11)) {
    	        	inputSPButton11();
    	    		inputTextBox.setText(amKR.getTextResult());    		       	
    	        }
    	        else if (arg0.widget.equals(ezhSpecialButton12)) {
    	        	inputSPButton12();
    	    		inputTextBox.setText(amKR.getTextResult());    		       	
    	        }
    	        else if (arg0.widget.equals(ezhSpecialButton13)) {
    	        	inputSPButton13();
    	    		inputTextBox.setText(amKR.getTextResult());    		       	
    	        }
    	        else if (arg0.widget.equals(ezhSpecialButton14)) {
    	        	inputSPButton14();
    	    		inputTextBox.setText(amKR.getTextResult());    		       	
    	        }
    	        else if (arg0.widget.equals(ezhSpecialButton15)) {
    	        	inputSPButton15();
    	    		inputTextBox.setText(amKR.getTextResult());    		       	
    	        }
    	        else if (arg0.widget.equals(ezhSpecialButton16)) {
    	        	inputSPButton16();
    	    		inputTextBox.setText(amKR.getTextResult());    		       	
    	        }
    	        else if (arg0.widget.equals(ezhSpecialButton17)) {
    	        	inputSPButton17();
    	    		inputTextBox.setText(amKR.getTextResult());    		       	
    	        }
    	        else if (arg0.widget.equals(ezhSpecialButton18)) {
    	        	inputSPButton18();
    	    		inputTextBox.setText(amKR.getTextResult());    		       	
    	        }
    	        else if (arg0.widget.equals(ezhSpecialButton19)) {
    	        	inputSPButton19();
    	    		inputTextBox.setText(amKR.getTextResult());    		       	
    	        }
    	        else if (arg0.widget.equals(ezhSpecialButton20)) {
    	        	inputSPButton20();
    	    		inputTextBox.setText(amKR.getTextResult());    		       	
    	        }
    	        else if (arg0.widget.equals(ezhSpecialButton21)) {
    	        	inputSPButton21();
    	    		inputTextBox.setText(amKR.getTextResult());    		       	
    	        }
    	        else if (arg0.widget.equals(ezhSpecialButton22)) {
    	        	inputSPButton22();
    	    		inputTextBox.setText(amKR.getTextResult());    		       	
    	        }
    	        else if (arg0.widget.equals(ezhSpecialButton23)) {
    	        	inputSPButton23();
    	    		inputTextBox.setText(amKR.getTextResult());    		       	
    	        }
    	        else if (arg0.widget.equals(ezhSpecialButton24)) {
    	        	inputSPButton24();
    	    		inputTextBox.setText(amKR.getTextResult());    		       	
    	        }
        	}    		
    	}
    	// qwerty 키보드일 경우
    	else {	 

            if (arg0.widget.equals(qwertyButton01)) {
            	inputQTButton01(isQwertyShift, isQwertyAlpha, isQwertySpkey);
	    		qtInputTextBox.setText(amKR.getTextResult());
            }
            else if (arg0.widget.equals(qwertyButton02)) {
            	inputQTButton02(isQwertyShift, isQwertyAlpha, isQwertySpkey);
	    		qtInputTextBox.setText(amKR.getTextResult());
            }
            else if (arg0.widget.equals(qwertyButton03)) {
            	inputQTButton03(isQwertyShift, isQwertyAlpha, isQwertySpkey);
	    		qtInputTextBox.setText(amKR.getTextResult());
            }
            else if (arg0.widget.equals(qwertyButton04)) {
            	inputQTButton04(isQwertyShift, isQwertyAlpha, isQwertySpkey);
	    		qtInputTextBox.setText(amKR.getTextResult());
            }
            else if (arg0.widget.equals(qwertyButton05)) {
            	inputQTButton05(isQwertyShift, isQwertyAlpha, isQwertySpkey);
	    		qtInputTextBox.setText(amKR.getTextResult());
            }
            else if (arg0.widget.equals(qwertyButton06)) {
            	inputQTButton06(isQwertyShift, isQwertyAlpha, isQwertySpkey);
	    		qtInputTextBox.setText(amKR.getTextResult());
            }
            else if (arg0.widget.equals(qwertyButton07)) {
            	inputQTButton07(isQwertyShift, isQwertyAlpha, isQwertySpkey);
	    		qtInputTextBox.setText(amKR.getTextResult());
            }
            else if (arg0.widget.equals(qwertyButton08)) {
            	inputQTButton08(isQwertyShift, isQwertyAlpha, isQwertySpkey);
	    		qtInputTextBox.setText(amKR.getTextResult());
            }
            else if (arg0.widget.equals(qwertyButton09)) {
            	inputQTButton09(isQwertyShift, isQwertyAlpha, isQwertySpkey);
	    		qtInputTextBox.setText(amKR.getTextResult());
            }
            else if (arg0.widget.equals(qwertyButton10)) {
            	inputQTButton10(isQwertyShift, isQwertyAlpha, isQwertySpkey);
	    		qtInputTextBox.setText(amKR.getTextResult());
            }
            else if (arg0.widget.equals(qwertyButton11)) {
            	inputQTButton11(isQwertyShift, isQwertyAlpha, isQwertySpkey);
	    		qtInputTextBox.setText(amKR.getTextResult());
            }
            else if (arg0.widget.equals(qwertyButton12)) {
            	inputQTButton12(isQwertyShift, isQwertyAlpha, isQwertySpkey);
	    		qtInputTextBox.setText(amKR.getTextResult());
            }
            else if (arg0.widget.equals(qwertyButton13)) {
            	inputQTButton13(isQwertyShift, isQwertyAlpha, isQwertySpkey);
	    		qtInputTextBox.setText(amKR.getTextResult());
            }
            else if (arg0.widget.equals(qwertyButton14)) {
            	inputQTButton14(isQwertyShift, isQwertyAlpha, isQwertySpkey);
	    		qtInputTextBox.setText(amKR.getTextResult());
            }
            else if (arg0.widget.equals(qwertyButton15)) {
            	inputQTButton15(isQwertyShift, isQwertyAlpha, isQwertySpkey);
	    		qtInputTextBox.setText(amKR.getTextResult());
            }
            else if (arg0.widget.equals(qwertyButton16)) {
            	inputQTButton16(isQwertyShift, isQwertyAlpha, isQwertySpkey);
	    		qtInputTextBox.setText(amKR.getTextResult());
            }
            else if (arg0.widget.equals(qwertyButton17)) {
            	inputQTButton17(isQwertyShift, isQwertyAlpha, isQwertySpkey);
	    		qtInputTextBox.setText(amKR.getTextResult());
            }
            else if (arg0.widget.equals(qwertyButton18)) {
            	inputQTButton18(isQwertyShift, isQwertyAlpha, isQwertySpkey);
	    		qtInputTextBox.setText(amKR.getTextResult());
            }
            else if (arg0.widget.equals(qwertyButton19)) {
            	inputQTButton19(isQwertyShift, isQwertyAlpha, isQwertySpkey);
	    		qtInputTextBox.setText(amKR.getTextResult());
            }
            else if (arg0.widget.equals(qwertyButton20)) {
            	inputQTButton20(isQwertyShift, isQwertyAlpha, isQwertySpkey);
	    		qtInputTextBox.setText(amKR.getTextResult());
            }
            else if (arg0.widget.equals(qwertyButton21)) {
            	inputQTButton21(isQwertyShift, isQwertyAlpha, isQwertySpkey);
	    		qtInputTextBox.setText(amKR.getTextResult());
            }
            else if (arg0.widget.equals(qwertyButton22)) {
            	inputQTButton22(isQwertyShift, isQwertyAlpha, isQwertySpkey);
	    		qtInputTextBox.setText(amKR.getTextResult());
            }
            else if (arg0.widget.equals(qwertyButton23)) {
            	inputQTButton23(isQwertyShift, isQwertyAlpha, isQwertySpkey);
	    		qtInputTextBox.setText(amKR.getTextResult());
            }
            else if (arg0.widget.equals(qwertyButton24)) {
            	inputQTButton24(isQwertyShift, isQwertyAlpha, isQwertySpkey);
	    		qtInputTextBox.setText(amKR.getTextResult());
            }
            else if (arg0.widget.equals(qwertyButton25)) {
            	inputQTButton25(isQwertyShift, isQwertyAlpha, isQwertySpkey);
	    		qtInputTextBox.setText(amKR.getTextResult());
            }
            else if (arg0.widget.equals(qwertyButton26)) {
            	inputQTButton26(isQwertyShift, isQwertyAlpha, isQwertySpkey);
	    		qtInputTextBox.setText(amKR.getTextResult());
            }
            else if (arg0.widget.equals(qwertyButton27)) {
            	inputQTButton27(isQwertyShift, isQwertyAlpha, isQwertySpkey);
	    		qtInputTextBox.setText(amKR.getTextResult());
            }
            else if (arg0.widget.equals(qwertyButton28)) {
            	inputQTButton28(isQwertyShift, isQwertyAlpha, isQwertySpkey);
	    		qtInputTextBox.setText(amKR.getTextResult());
            }
            else if (arg0.widget.equals(qwertyButton29)) {
            	inputQTButton29(isQwertyShift, isQwertyAlpha, isQwertySpkey);
	    		qtInputTextBox.setText(amKR.getTextResult());
            }
            else if (arg0.widget.equals(qwertyButton30)) {
            	inputQTButton30(isQwertyShift, isQwertyAlpha, isQwertySpkey);
	    		qtInputTextBox.setText(amKR.getTextResult());
            }
            else if (arg0.widget.equals(qwertyButton34)) {
            	spaceButton();
	    		qtInputTextBox.setText(amKR.getTextResult());
            }  
            else if (arg0.widget.equals(qwertyButton35)) {
            	enterButton();
            	qtInputTextBox.setText(amKR.getTextResult());
            }  
    	}
    	
    	if (isQwerty) {
    		qtStatusTextBox.setText(String.valueOf(amKR.getTextLength()));
    	}
    	else {
    		statusTextBox.setText(String.valueOf(amKR.getTextLength()));
    	}
    }
    

	/**************************************************************************
     * Handler Start 
     *************************************************************************/
    
	//
	public void inputButton01() {
		clearBtnStatus();
		insertEZHangul('r', true);	// ㄱ		
	}
	
	public void inputButton02() {
		clearBtnStatus();
		insertEZHangul('s', true);	// ㄴ
	}
		
	public void inputButton03() {
		
		if (btnStatus03 == 0) {
			insertEZHangul('k', true);	// ㅏ
			btnStatus03 = 'k';
		}
		else if (btnStatus03 == 'k') {
			insertEZHangul('j', false);	// ㅓ
			btnStatus03 = 'j';
		}
		else if (btnStatus03 == 'j') {
			insertEZHangul('k', false);	// ㅏ
			btnStatus03 = 'k';
		}
		
		btnStatus06 = 0;
	}
	
	public void inputButton04() {
		clearBtnStatus();
		insertEZHangul('f', true);	// ㄹ
		
	}
	
	public void inputButton05() {
		clearBtnStatus();
		insertEZHangul('a', true);	// ㅁ
	}
	
	public void inputButton06() {
		if (btnStatus06 == 0) {
			insertEZHangul('h', true);	// ㅗ
			btnStatus06 = 'h';
		}
		else if (btnStatus06 == 'h') {
			insertEZHangul('n', false);	// ㅗ
			btnStatus06 = 'n';
		}
		else if (btnStatus06 == 'n') {
			insertEZHangul('h', false);	// ㅜ
			btnStatus06 = 'h';
		}
		
		btnStatus03 = 0;
	}
	
	public void inputButton07() {
		clearBtnStatus();
		insertEZHangul('t', true);	// ㅅ
	}
	
	public void inputButton08() {
		clearBtnStatus();
		insertEZHangul('d', true);	// ㅇ
	}
	
	public void inputButton09() {
		clearBtnStatus();
			
		if (lastInput == 'k') {
			insertEZHangul('o', false);	// ㅐ
		}
		else if (lastInput == 'j') {
			insertEZHangul('p', false);	// ㅔ
		}
		else {
			insertEZHangul('l', true);	// ㅣ
		}
	}
	
	public void inputButton10() {	// *키

		switch (lastInput) {
		case 's':	// ㄴ 
			insertEZHangul('e', false);
			break;
		case 'e':
			insertEZHangul('x', false);
			break;
		case 'x':
			insertEZHangul('s', false);
			break;
			
		case 'r':	// ㄱ 
			insertEZHangul('z', false);
			break;
		case 'z':
			insertEZHangul('r', false);
			break;
			
		case 'a':	// ㅁ
			insertEZHangul('q', false);
			break;
		case 'q':
			insertEZHangul('v', false);
			break;
		case 'v':
			insertEZHangul('a', false);
			break;
			
		case 't':	// ㅅ
			insertEZHangul('w', false);
			break;
		case 'w':
			insertEZHangul('c', false);
			break;
		case 'c':
			insertEZHangul('t', false);
			break;
			
		case 'd':	// ㅇ
			insertEZHangul('g', false);
			break;
		case 'g':
			insertEZHangul('d', false);
			break;
			
		case 'k':	// ㅏ-> ㅑ
			insertEZHangul('i', false);
			btnStatus03 = 0;
			break;
		case 'i':
			insertEZHangul('k', false);
			btnStatus03 = 'k';
			break;
			
		case 'j':	// ㅓ-> ㅕ
			insertEZHangul('u', false);
			btnStatus03 = 0;
			break;
		case 'u':
			insertEZHangul('j', false);
			btnStatus03 = 'j';
			break;
			
		case 'h':	// ㅗ-> ㅛ
			insertEZHangul('y', false);
			btnStatus06 = 0;
			break;
		case 'y':
			insertEZHangul('h', false);
			btnStatus06 = 'h';
			break;
			
		case 'n':	// ㅜ-> ㅠ
			insertEZHangul('b', false);
			btnStatus06 = 0;
			break;
		case 'b':
			insertEZHangul('n', false);
			btnStatus06 = 'n';
			break;
			
		case 'o':	// ㅐ-> ㅒ
			insertEZHangul('O', false);
			break;
		case 'O':
			insertEZHangul('o', false);
			break;
			
		case 'p':	// ㅔ -> ㅖ
 			insertEZHangul('P', false);
			break;
		case 'P':
			insertEZHangul('p', false);
			break;
			
		default:
			break;
		}
		
	}
	
	public void inputButton11() {

		clearBtnStatus();
		insertEZHangul('m', true);	// ㅡ
	}
	
	public void inputButton12() {	// #키

		switch (lastInput) {
			
		case 'r':
			insertEZHangul('R', false);
			break;
		case 'R':
			insertEZHangul('r', false);
			break;
			
		case 'e':
			insertEZHangul('E', false);
			break;
		case 'E':
			insertEZHangul('e', false);
			break;
			
		case 'q':
			insertEZHangul('Q', false);
			break;
		case 'Q':
			insertEZHangul('q', false);
			break;
			
		case 't':
			insertEZHangul('T', false);
			break;
		case 'T':
			insertEZHangul('t', false);
			break;
			
		case 'w':
			insertEZHangul('W', false);
			break;
		case 'W':
			insertEZHangul('w', false);
			break;
			
		default:
			break;
		}
	}
	
	public void inputSPButton01() {
		
		if (isSpecialKey01) {
			amKR.insertSpecialKey(spKeyString[0], false);
		}
		else {
			amKR.insertSpecialKey(spKeyString[24], false);
		}
		lastInput = 0;	
	}	
	
	public void inputSPButton02() {
		if (isSpecialKey01) 
			amKR.insertSpecialKey(spKeyString[1], false);
		else 
			amKR.insertSpecialKey(spKeyString[25], false);
		
		lastInput = 0;		
	}
	
	public void inputSPButton03() {
		if (isSpecialKey01) 
			amKR.insertSpecialKey(spKeyString[2], false);
		else 
			amKR.insertSpecialKey(spKeyString[26], false);
		
		lastInput = 0;	
	}
	
	public void inputSPButton04() {
		if (isSpecialKey01) 
			amKR.insertSpecialKey(spKeyString[3], false);
		else 
			amKR.insertSpecialKey(spKeyString[27], false);
		
		lastInput = 0;		
	}
	
	public void inputSPButton05() {
		if (isSpecialKey01) 
			amKR.insertSpecialKey(spKeyString[4], false);
		else 
			amKR.insertSpecialKey(spKeyString[28], false);
		
		lastInput = 0;	
	}
	
	public void inputSPButton06() {
		if (isSpecialKey01) 
			amKR.insertSpecialKey(spKeyString[5], false);
		else 
			amKR.insertSpecialKey(spKeyString[29], false);
		
		lastInput = 0;		
	}
	
	public void inputSPButton07() {
		if (isSpecialKey01) 
			amKR.insertSpecialKey(spKeyString[6], false);
		else 
			amKR.insertSpecialKey(spKeyString[30], false);
		
		lastInput = 0;	
	}
	
	public void inputSPButton08() {
		if (isSpecialKey01) 
			amKR.insertSpecialKey(spKeyString[7], false);
		else 
			amKR.insertSpecialKey(spKeyString[31], false);
		
		lastInput = 0;		
	}
	
	public void inputSPButton09() {
		if (isSpecialKey01) 
			amKR.insertSpecialKey(spKeyString[8], false);
		else 
			amKR.insertSpecialKey(spKeyString[32], false);
		
		lastInput = 0;		
	}
	
	public void inputSPButton10() {
		if (isSpecialKey01) 
			amKR.insertSpecialKey(spKeyString[9], false);
		else 
			amKR.insertSpecialKey(spKeyString[33], false);
		
		lastInput = 0;		
	}
	
	public void inputSPButton11() {
		if (isSpecialKey01) 
			amKR.insertSpecialKey(spKeyString[10], false);
		else 
			amKR.insertSpecialKey(spKeyString[34], false);
		
		lastInput = 0;	
	}
	
	public void inputSPButton12() {
		if (isSpecialKey01) 
			amKR.insertSpecialKey(spKeyString[11], false);
		else 
			amKR.insertSpecialKey(spKeyString[35], false);
		
		lastInput = 0;		
	}
	
	public void inputSPButton13() {
		if (isSpecialKey01) 
			amKR.insertSpecialKey(spKeyString[12], false);
		else 
			amKR.insertSpecialKey(spKeyString[36], false);
		
		lastInput = 0;		
	}
	
	public void inputSPButton14() {
		if (isSpecialKey01) 
			amKR.insertSpecialKey(spKeyString[13], false);
		else 
			amKR.insertSpecialKey(spKeyString[37], false);
		
		lastInput = 0;		
	}
	
	public void inputSPButton15() {
		if (isSpecialKey01) 
			amKR.insertSpecialKey(spKeyString[14], false);
		else 
			amKR.insertSpecialKey(spKeyString[38], false);
		
		lastInput = 0;		
	}
	
	public void inputSPButton16() {
		if (isSpecialKey01) 
			amKR.insertSpecialKey(spKeyString[15], false);
		else 
			amKR.insertSpecialKey(spKeyString[39], false);
		
		lastInput = 0;		
	}
	
	public void inputSPButton17() {
		if (isSpecialKey01) 
			amKR.insertSpecialKey(spKeyString[16], false);
		else 
			amKR.insertSpecialKey(spKeyString[40], false);
		
		lastInput = 0;	
	}
	
	public void inputSPButton18() {
		if (isSpecialKey01) 
			amKR.insertSpecialKey(spKeyString[17], false);
		else 
			amKR.insertSpecialKey(spKeyString[41], false);
		
		lastInput = 0;	
	}
	
	public void inputSPButton19() {
		if (isSpecialKey01) 
			amKR.insertSpecialKey(spKeyString[18], false);
		else 
			amKR.insertSpecialKey(spKeyString[42], false);
		
		lastInput = 0;		
	}
	
	public void inputSPButton20() {
		if (isSpecialKey01) 
			amKR.insertSpecialKey(spKeyString[19], false);
		else 
			amKR.insertSpecialKey(spKeyString[43], false);
		
		lastInput = 0;	
	}
	
	public void inputSPButton21() {
		if (isSpecialKey01) 
			amKR.insertSpecialKey(spKeyString[20], false);
		else 
			amKR.insertSpecialKey(spKeyString[44], false);
		
		lastInput = 0;		
	}
	
	public void inputSPButton22() {
		if (isSpecialKey01) 
			amKR.insertSpecialKey(spKeyString[21], false);
		else 
			amKR.insertSpecialKey(spKeyString[45], false);
		
		lastInput = 0;	
	}
	
	public void inputSPButton23() {
		if (isSpecialKey01) 
			amKR.insertSpecialKey(spKeyString[22], false);
		else 
			amKR.insertSpecialKey(spKeyString[46], false);
		
		lastInput = 0;		
	}
	
	public void inputSPButton24() {
		if (isSpecialKey01) 
			amKR.insertSpecialKey(spKeyString[23], false);
		else 
			amKR.insertSpecialKey(spKeyString[47], false);
		
		lastInput = 0;	
	}
	
	// qwerty
	public void inputQTButton01(boolean isShift, boolean isAlpha, boolean isSpeacial){
		
		if (!isAlpha && !isSpeacial && !isShift) {	// 한글
			insertQwerty('q', true);
		}
		else if (!isAlpha && !isSpeacial && isShift) {	// 한글 shift
			insertQwerty('Q', true);
		}
		else if (isAlpha && !isSpeacial && isShift) {	// 영문 shift shift
			amKR.insertSpecialKey("Q", false);
			lastInput = 0;
		}
		else if (isAlpha && !isSpeacial && !isShift) {	// 영문
			amKR.insertSpecialKey("q", false);
			lastInput = 0;
		}
		else if (isSpeacial) {	// 특수문자
			amKR.insertSpecialKey(spKeyString[0], false);
			lastInput = 0;
		}
	}
	
	public void inputQTButton02(boolean isShift, boolean isAlpha, boolean isSpeacial){
		if (!isAlpha && !isSpeacial && !isShift) {	// 한글
			insertQwerty('w', true);
		}
		else if (!isAlpha && !isSpeacial && isShift) {	// 한글 shift
			insertQwerty('W', true);
		}
		else if (isAlpha && !isSpeacial && isShift) {	// 영문 shift
			amKR.insertSpecialKey("W", false);
			lastInput = 0;
		}
		else if (isAlpha && !isSpeacial && !isShift) {	// 영문
			amKR.insertSpecialKey("w", false);
			lastInput = 0;
		}
		else if (isSpeacial) {	// 특수문자
			amKR.insertSpecialKey(spKeyString[1], false);
			lastInput = 0;
		}
	}
	
	public void inputQTButton03(boolean isShift, boolean isAlpha, boolean isSpeacial){
		if (!isAlpha && !isSpeacial && !isShift) {	// 한글
			insertQwerty('e', true);
		}
		else if (!isAlpha && !isSpeacial && isShift) {	// 한글 shift
			insertQwerty('E', true);
		}
		else if (isAlpha && !isSpeacial && isShift) {	// 영문 shift
			amKR.insertSpecialKey("E", false);
			lastInput = 0;
		}
		else if (isAlpha && !isSpeacial && !isShift) {	// 영문
			amKR.insertSpecialKey("e", false);
			lastInput = 0;
		}
		else if (isSpeacial) {	// 특수문자
			amKR.insertSpecialKey(spKeyString[2], false);
			lastInput = 0;
		}
	}
	
	public void inputQTButton04(boolean isShift, boolean isAlpha, boolean isSpeacial){
		if (!isAlpha && !isSpeacial && !isShift) {	// 한글
			insertQwerty('r', true);
		}
		else if (!isAlpha && !isSpeacial && isShift) {	// 한글 shift
			insertQwerty('R', true);
		}
		else if (isAlpha && !isSpeacial && isShift) {	// 영문 shift
			amKR.insertSpecialKey("R", false);
			lastInput = 0;
		}
		else if (isAlpha && !isSpeacial && !isShift) {	// 영문
			amKR.insertSpecialKey("r", false);
			lastInput = 0;
		}
		else if (isSpeacial) {	// 특수문자
			amKR.insertSpecialKey(spKeyString[3], false);
			lastInput = 0;
		}
	}
	
	public void inputQTButton05(boolean isShift, boolean isAlpha, boolean isSpeacial){
		if (!isAlpha && !isSpeacial && !isShift) {	// 한글
			insertQwerty('t', true);
		}
		else if (!isAlpha && !isSpeacial && isShift) {	// 한글 shift
			insertQwerty('T', true);
		}
		else if (isAlpha && !isSpeacial && isShift) {	// 영문 shift
			amKR.insertSpecialKey("T", false);
			lastInput = 0;
		}
		else if (isAlpha && !isSpeacial && !isShift) {	// 영문
			amKR.insertSpecialKey("t", false);
			lastInput = 0;
		}
		else if (isSpeacial) {	// 특수문자
			amKR.insertSpecialKey(spKeyString[4], false);
			lastInput = 0;
		}
	}
	
	public void inputQTButton06(boolean isShift, boolean isAlpha, boolean isSpeacial){
		if (!isAlpha && !isSpeacial && !isShift) {	// 한글
			insertQwerty('y', true);
		}
		else if (!isAlpha && !isSpeacial && isShift) {	// 한글 shift
			insertQwerty('y', true);
		}
		else if (isAlpha && !isSpeacial && isShift) {	// 영문 shift
			amKR.insertSpecialKey("Y", false);
			lastInput = 0;
		}
		else if (isAlpha && !isSpeacial && !isShift) {	// 영문
			amKR.insertSpecialKey("y", false);
			lastInput = 0;
		}
		else if (isSpeacial) {	// 특수문자
			amKR.insertSpecialKey(spKeyString[5], false);
			lastInput = 0;
		}
	}
	
	public void inputQTButton07(boolean isShift, boolean isAlpha, boolean isSpeacial){
		if (!isAlpha && !isSpeacial && !isShift) {	// 한글
			insertQwerty('u', true);
		}
		else if (!isAlpha && !isSpeacial && isShift) {	// 한글 shift
			insertQwerty('u', true);
		}
		else if (isAlpha && !isSpeacial && isShift) {	// 영문 shift
			amKR.insertSpecialKey("U", false);
			lastInput = 0;
		}
		else if (isAlpha && !isSpeacial && !isShift) {	// 영문
			amKR.insertSpecialKey("u", false);
			lastInput = 0;
		}
		else if (isSpeacial) {	// 특수문자
			amKR.insertSpecialKey(spKeyString[6], false);
			lastInput = 0;
		}
	}
	
	public void inputQTButton08(boolean isShift, boolean isAlpha, boolean isSpeacial){
		if (!isAlpha && !isSpeacial && !isShift) {	// 한글
			insertQwerty('i', true);
		}
		else if (!isAlpha && !isSpeacial && isShift) {	// 한글 shift
			insertQwerty('i', true);
		}
		else if (isAlpha && !isSpeacial && isShift) {	// 영문 shift
			amKR.insertSpecialKey("I", false);
			lastInput = 0;
		}
		else if (isAlpha && !isSpeacial && !isShift) {	// 영문
			amKR.insertSpecialKey("i", false);
			lastInput = 0;
		}
		else if (isSpeacial) {	// 특수문자
			amKR.insertSpecialKey(spKeyString[7], false);
			lastInput = 0;
		}
	}
	
	public void inputQTButton09(boolean isShift, boolean isAlpha, boolean isSpeacial){
		if (!isAlpha && !isSpeacial && !isShift) {	// 한글
			insertQwerty('o', true);
		}
		else if (!isAlpha && !isSpeacial && isShift) {	// 한글 shift
			insertQwerty('O', true);
		}
		else if (isAlpha && !isSpeacial && isShift) {	// 영문 shift
			amKR.insertSpecialKey("O", false);
			lastInput = 0;
		}
		else if (isAlpha && !isSpeacial && !isShift) {	// 영문
			amKR.insertSpecialKey("o", false);
			lastInput = 0;
		}
		else if (isSpeacial) {	// 특수문자
			amKR.insertSpecialKey(spKeyString[8], false);
			lastInput = 0;
		}
	}
	
	public void inputQTButton10(boolean isShift, boolean isAlpha, boolean isSpeacial){
		if (!isAlpha && !isSpeacial && !isShift) {	// 한글
			insertQwerty('p', true);
		}
		else if (!isAlpha && !isSpeacial && isShift) {	// 한글 shift
			insertQwerty('P', true);
		}
		else if (isAlpha && !isSpeacial && isShift) {	// 영문 shift
			amKR.insertSpecialKey("P", false);
			lastInput = 0;
		}
		else if (isAlpha && !isSpeacial && !isShift) {	// 영문
			amKR.insertSpecialKey("p", false);
			lastInput = 0;
		}
		else if (isSpeacial) {	// 특수문자
			amKR.insertSpecialKey(spKeyString[9], false);
			lastInput = 0;
		}
	}
	
	public void inputQTButton11(boolean isShift, boolean isAlpha, boolean isSpeacial){
		if (!isAlpha && !isSpeacial && !isShift) {	// 한글
			insertQwerty('a', true);
		}
		else if (!isAlpha && !isSpeacial && isShift) {	// 한글 shift
			insertQwerty('a', true);
		}
		else if (isAlpha && !isSpeacial && isShift) {	// 영문 shift
			amKR.insertSpecialKey("A", false);
			lastInput = 0;
		}
		else if (isAlpha && !isSpeacial && !isShift) {	// 영문
			amKR.insertSpecialKey("a", false);
			lastInput = 0;
		}
		else if (isSpeacial) {	// 특수문자
			amKR.insertSpecialKey(spKeyString[10], false);
			lastInput = 0;
		}
	}
	
	public void inputQTButton12(boolean isShift, boolean isAlpha, boolean isSpeacial){
		if (!isAlpha && !isSpeacial && !isShift) {	// 한글
			insertQwerty('s', true);
		}
		else if (!isAlpha && !isSpeacial && isShift) {	// 한글 shift
			insertQwerty('s', true);
		}
		else if (isAlpha && !isSpeacial && isShift) {	// 영문 shift
			amKR.insertSpecialKey("S", false);
			lastInput = 0;
		}
		else if (isAlpha && !isSpeacial && !isShift) {	// 영문
			amKR.insertSpecialKey("s", false);
			lastInput = 0;
		}
		else if (isSpeacial) {	// 특수문자
			amKR.insertSpecialKey(spKeyString[11], false);
			lastInput = 0;
		}
	}
	
	public void inputQTButton13(boolean isShift, boolean isAlpha, boolean isSpeacial){
		if (!isAlpha && !isSpeacial && !isShift) {	// 한글
			insertQwerty('d', true);
		}
		else if (!isAlpha && !isSpeacial && isShift) {	// 한글 shift
			insertQwerty('d', true);
		}
		else if (isAlpha && !isSpeacial && isShift) {	// 영문 shift
			amKR.insertSpecialKey("D", false);
			lastInput = 0;
		}
		else if (isAlpha && !isSpeacial && !isShift) {	// 영문
			amKR.insertSpecialKey("d", false);
			lastInput = 0;
		}
		else if (isSpeacial) {	// 특수문자
			amKR.insertSpecialKey(spKeyString[12], false);
			lastInput = 0;
		}
	}
	
	public void inputQTButton14(boolean isShift, boolean isAlpha, boolean isSpeacial){
		if (!isAlpha && !isSpeacial && !isShift) {	// 한글
			insertQwerty('f', true);
		}
		else if (!isAlpha && !isSpeacial && isShift) {	// 한글 shift
			insertQwerty('f', true);
		}
		else if (isAlpha && !isSpeacial && isShift) {	// 영문 shift
			amKR.insertSpecialKey("F", false);
			lastInput = 0;
		}
		else if (isAlpha && !isSpeacial && !isShift) {	// 영문
			amKR.insertSpecialKey("f", false);
			lastInput = 0;
		}
		else if (isSpeacial) {	// 특수문자
			amKR.insertSpecialKey(spKeyString[13], false);
			lastInput = 0;
		}
	}
	
	public void inputQTButton15(boolean isShift, boolean isAlpha, boolean isSpeacial){
		if (!isAlpha && !isSpeacial && !isShift) {	// 한글
			insertQwerty('g', true);
		}
		else if (!isAlpha && !isSpeacial && isShift) {	// 한글 shift
			insertQwerty('g', true);
		}
		else if (isAlpha && !isSpeacial && isShift) {	// 영문 shift
			amKR.insertSpecialKey("G", false);
			lastInput = 0;
		}
		else if (isAlpha && !isSpeacial && !isShift) {	// 영문
			amKR.insertSpecialKey("g", false);
			lastInput = 0;
		}
		else if (isSpeacial) {	// 특수문자
			amKR.insertSpecialKey(spKeyString[14], false);
			lastInput = 0;
		}
	}
	
	public void inputQTButton16(boolean isShift, boolean isAlpha, boolean isSpeacial){
		if (!isAlpha && !isSpeacial && !isShift) {	// 한글
			insertQwerty('h', true);
		}
		else if (!isAlpha && !isSpeacial && isShift) {	// 한글 shift
			insertQwerty('h', true);
		}
		else if (isAlpha && !isSpeacial && isShift) {	// 영문 shift
			amKR.insertSpecialKey("H", false);
			lastInput = 0;
		}
		else if (isAlpha && !isSpeacial && !isShift) {	// 영문
			amKR.insertSpecialKey("h", false);
			lastInput = 0;
		}
		else if (isSpeacial) {	// 특수문자
			amKR.insertSpecialKey(spKeyString[15], false);
			lastInput = 0;
		}
	}
	
	public void inputQTButton17(boolean isShift, boolean isAlpha, boolean isSpeacial){
		if (!isAlpha && !isSpeacial && !isShift) {	// 한글
			insertQwerty('j', true);
		}
		else if (!isAlpha && !isSpeacial && isShift) {	// 한글 shift
			insertQwerty('j', true);
		}
		else if (isAlpha && !isSpeacial && isShift) {	// 영문 shift
			amKR.insertSpecialKey("J", false);
			lastInput = 0;
		}
		else if (isAlpha && !isSpeacial && !isShift) {	// 영문
			amKR.insertSpecialKey("j", false);
			lastInput = 0;
		}
		else if (isSpeacial) {	// 특수문자
			amKR.insertSpecialKey(spKeyString[16], false);
			lastInput = 0;
		}
	}
	
	public void inputQTButton18(boolean isShift, boolean isAlpha, boolean isSpeacial){
		if (!isAlpha && !isSpeacial && !isShift) {	// 한글
			insertQwerty('k', true);
		}
		else if (!isAlpha && !isSpeacial && isShift) {	// 한글 shift
			insertQwerty('k', true);
		}
		else if (isAlpha && !isSpeacial && isShift) {	// 영문 shift
			amKR.insertSpecialKey("K", false);
			lastInput = 0;
		}
		else if (isAlpha && !isSpeacial && !isShift) {	// 영문
			amKR.insertSpecialKey("k", false);
			lastInput = 0;
		}
		else if (isSpeacial) {	// 특수문자
			amKR.insertSpecialKey(spKeyString[17], false);
			lastInput = 0;
		}
	}
	
	public void inputQTButton19(boolean isShift, boolean isAlpha, boolean isSpeacial){
		if (!isAlpha && !isSpeacial && !isShift) {	// 한글
			insertQwerty('l', true);
		}
		else if (!isAlpha && !isSpeacial && isShift) {	// 한글 shift
			insertQwerty('l', true);
		}
		else if (isAlpha && !isSpeacial && isShift) {	// 영문 shift
			amKR.insertSpecialKey("L", false);
			lastInput = 0;
		}
		else if (isAlpha && !isSpeacial && !isShift) {	// 영문
			amKR.insertSpecialKey("l", false);
			lastInput = 0;
		}
		else if (isSpeacial) {	// 특수문자
			amKR.insertSpecialKey(spKeyString[18], false);
			lastInput = 0;
		}
	}
	
	public void inputQTButton20(boolean isShift, boolean isAlpha, boolean isSpeacial){
		amKR.insertSpecialKey(qwertyButton20.getText(), false);		
		lastInput = 0;
	}
	
	public void inputQTButton21(boolean isShift, boolean isAlpha, boolean isSpeacial){
		if (!isAlpha && !isSpeacial && !isShift) {	// 한글
			insertQwerty('z', true);
		}
		else if (!isAlpha && !isSpeacial && isShift) {	// 한글 shift
			insertQwerty('z', true);
		}
		else if (isAlpha && !isSpeacial && isShift) {	// 영문 shift
			amKR.insertSpecialKey("Z", false);
			lastInput = 0;
		}
		else if (isAlpha && !isSpeacial && !isShift) {	// 영문
			amKR.insertSpecialKey("z", false);
			lastInput = 0;
		}
		else if (isSpeacial) {	// 특수문자
			amKR.insertSpecialKey(spKeyString[20], false);
			lastInput = 0;
		}
	}
	
	public void inputQTButton22(boolean isShift, boolean isAlpha, boolean isSpeacial){
		if (!isAlpha && !isSpeacial && !isShift) {	// 한글
			insertQwerty('x', true);
		}
		else if (!isAlpha && !isSpeacial && isShift) {	// 한글 shift
			insertQwerty('x', true);
		}
		else if (isAlpha && !isSpeacial && isShift) {	// 영문 shift
			amKR.insertSpecialKey("X", false);
			lastInput = 0;
		}
		else if (isAlpha && !isSpeacial && !isShift) {	// 영문
			amKR.insertSpecialKey("x", false);
			lastInput = 0;
		}
		else if (isSpeacial) {	// 특수문자
			amKR.insertSpecialKey(spKeyString[21], false);
			lastInput = 0;
		}
	}
	
	public void inputQTButton23(boolean isShift, boolean isAlpha, boolean isSpeacial){
		if (!isAlpha && !isSpeacial && !isShift) {	// 한글
			insertQwerty('c', true);
		}
		else if (!isAlpha && !isSpeacial && isShift) {	// 한글 shift
			insertQwerty('c', true);
		}
		else if (isAlpha && !isSpeacial && isShift) {	// 영문 shift
			amKR.insertSpecialKey("C", false);
			lastInput = 0;
		}
		else if (isAlpha && !isSpeacial && !isShift) {	// 영문
			amKR.insertSpecialKey("c", false);
			lastInput = 0;
		}
		else if (isSpeacial) {	// 특수문자
			amKR.insertSpecialKey(spKeyString[22], false);
			lastInput = 0;
		}
	}
	
	public void inputQTButton24(boolean isShift, boolean isAlpha, boolean isSpeacial){
		if (!isAlpha && !isSpeacial && !isShift) {	// 한글
			insertQwerty('v', true);
		}
		else if (!isAlpha && !isSpeacial && isShift) {	// 한글 shift
			insertQwerty('v', true);
		}
		else if (isAlpha && !isSpeacial && isShift) {	// 영문 shift
			amKR.insertSpecialKey("V", false);
			lastInput = 0;
		}
		else if (isAlpha && !isSpeacial && !isShift) {	// 영문
			amKR.insertSpecialKey("v", false);
			lastInput = 0;
		}
		else if (isSpeacial) {	// 특수문자
			amKR.insertSpecialKey(spKeyString[23], false);
			lastInput = 0;
		}
	}
	
	public void inputQTButton25(boolean isShift, boolean isAlpha, boolean isSpeacial){
		if (!isAlpha && !isSpeacial && !isShift) {	// 한글
			insertQwerty('b', true);
		}
		else if (!isAlpha && !isSpeacial && isShift) {	// 한글 shift
			insertQwerty('b', true);
		}
		else if (isAlpha && !isSpeacial && isShift) {	// 영문 shift
			amKR.insertSpecialKey("B", false);
			lastInput = 0;
		}
		else if (isAlpha && !isSpeacial && !isShift) {	// 영문
			amKR.insertSpecialKey("b", false);
			lastInput = 0;
		}
		else if (isSpeacial) {	// 특수문자
			amKR.insertSpecialKey(spKeyString[24], false);
			lastInput = 0;
		}
	}
	
	public void inputQTButton26(boolean isShift, boolean isAlpha, boolean isSpeacial){
		if (!isAlpha && !isSpeacial && !isShift) {	// 한글
			insertQwerty('n', true);
		}
		else if (!isAlpha && !isSpeacial && isShift) {	// 한글 shift
			insertQwerty('n', true);
		}
		else if (isAlpha && !isSpeacial && isShift) {	// 영문 shift
			amKR.insertSpecialKey("N", false);
			lastInput = 0;
		}
		else if (isAlpha && !isSpeacial && !isShift) {	// 영문
			amKR.insertSpecialKey("n", false);
			lastInput = 0;
		}
		else if (isSpeacial) {	// 특수문자
			amKR.insertSpecialKey(spKeyString[25], false);
			lastInput = 0;
		}
	}
	
	public void inputQTButton27(boolean isShift, boolean isAlpha, boolean isSpeacial){
		if (!isAlpha && !isSpeacial && !isShift) {	// 한글
			insertQwerty('m', true);
		}
		else if (!isAlpha && !isSpeacial && isShift) {	// 한글 shift
			insertQwerty('m', true);
		}
		else if (isAlpha && !isSpeacial && isShift) {	// 영문 shift
			amKR.insertSpecialKey("M", false);
			lastInput = 0;
		}
		else if (isAlpha && !isSpeacial && isShift) {	// 영문
			amKR.insertSpecialKey("m", false);
			lastInput = 0;
		}
		else if (isSpeacial) {	// 특수문자
			amKR.insertSpecialKey(spKeyString[26], false);
			lastInput = 0;
		}
	}
	
	public void inputQTButton28(boolean isShift, boolean isAlpha, boolean isSpeacial){
		amKR.insertSpecialKey(qwertyButton28.getText(), false);
		lastInput = 0;
	}
	
	public void inputQTButton29(boolean isShift, boolean isAlpha, boolean isSpeacial){
		amKR.insertSpecialKey(qwertyButton29.getText(), false);
		lastInput = 0;
	}
	
	public void inputQTButton30(boolean isShift, boolean isAlpha, boolean isSpeacial){
		amKR.insertSpecialKey(qwertyButton30.getText(), false);
		lastInput = 0;
	}
	
	public void enterButton(){
		amKR.insertSpecialKey("\r\n", false);
		lastInput = 0;
	}
	
	public void spaceButton() {
		amKR.insertSpecialKey(" ", false);	// space
		lastInput = 0;	
	}
	
	public void backspaceButton() {		// backspace
		amKR.insertBackspace();				
	}
	
	private void insertEZHangul(char ch, boolean insert) {
		amKR.insertEZHangul(ch, insert);
		lastInput = amKR.getLastInput();
	}
	
	private void insertQwerty(char ch, boolean insert) {
		amKR.insertQwertyHangul(ch, insert);
	}
	
	public void clearText() {
		amKR.clearInputText();
	}
	
	/**************************************************************************
     * Handler End 
     *************************************************************************/
     
}